unit DoIt;

interface

uses FileCtrl, main, classes, dialogs, filedata, SysUtils, Forms, GProg, ToDo;
procedure MainLoop;
procedure UpdateToDo;
procedure Sleep;

implementation

uses progress;



procedure Connect;
var a: integer;
    Action: TDoThis;
    t: TDateTime;
begin
    FrmProgress.LstActive.Items[0].SubItems[0]:='Initiating connections';
    CActive:=true;
    for a:=1 to FrmMain.SpnNumConnections.Value do begin
        FrmProgress.LstActive.Items[a].SubItems[0]:='Connecting...';
        CActive:=true;
        Connection[a].HostName:=FrmMain.TxtHost.Text;
        Connection[a].UserName:=FrmMain.TxtUser.Text;
        Connection[a].Password:=FrmMain.TxtPass.Text;
        Connection[a].OpenAsync;
    end;
    FrmProgress.LstActive.Items[0].SubItems[0]:='Waiting for remote actions to complete';
    CActive:=true;
end;



procedure ReadLocalDirectories;
var DirList: TDirectoryListBox;
    FileList: TFileListBox;
    LocalDirs: TStringList;
    CurDir: Integer;
    a: integer;
    f: boolean;
    NewDir: PTDirInfo;
    NewFile: PTFileInfo;
    t: TDateTime;
    FS: string;
    fdata: TSearchrec;
begin
    t:=now;
    DirList:=TDirectoryListBox.Create(Nil);
    DirList.Visible:=false;
    DirList.Parent:=FrmProgress;
    LocalDirs:=TStringList.Create;
    LocalDirs.Add(FrmMain.TxtLocalRoot.Text);
    CurDir:=0;
    while CurDir<LocalDirs.Count do begin
          DirList.Directory:=LocalDirs.Strings[CurDir];
          f:=false;
          for a:=0 to DirList.Items.Count-1 do begin
              if f then LocalDirs.Add(DirList.GetItemPath(a));
              if lowercase(DirList.GetItemPath(a))=
                 lowercase(LocalDirs.Strings[CurDir])
              then f:=true;
          end;
          CurDir:=CurDir+1;
          if Now-t>RefreshDelay then begin
             FrmProgress.LstActive.Items[0].SubItems[0]:='Scanning local copy: '+
                                                         'Found '+inttostr(CurDir)+
                                                         ' directories';
             CActive:=true;
             Application.ProcessMessages;
             t:=now;
          end;
    end;
    DirList.Destroy;
    { found all the dirs, scan them for files and add data to 'global' tree }
    FileList:=TFileListBox.Create(Nil);
    FileList.Visible:=false;
    FileList.Parent:=FrmProgress;
    NumLocalFiles:=0;
    LocalDirs.Sort;
    for CurDir:=0 to LocalDirs.Count-1 do begin
        if copy(LocalDirs.Strings[CurDir], length(LocalDirs.Strings[CurDir]), 1)<>'\' then
           LocalDirs.Strings[CurDir]:=LocalDirs.Strings[CurDir]+'\';
        NewDir:=AddDirectory(PathToInternal(LocalDirs.Strings[CurDir]), true);
{        NewDir:=AddDirectory(LocalDirs.Strings[CurDir], true);}
        NewDir.Local:=true;
        if CurDir<>0 then AddToToDoList(NewDir, TDRemDirCreate);
        FileList.Directory:=LocalDirs.Strings[CurDir];
        For a:=0 to FileList.Items.Count-1 do begin
            NewFile:=AddFile(FileList.Items[a], true, NewDir);
            FS:=LocalDirs.Strings[CurDir]+FileList.Items[a];
            FindFirst(FS, faAnyFile, fdata);
            NewFile.Local.Size:=fdata.Size;
            FindClose(fdata);
            if FrmMain.OptUploadAll.Checked then begin
               AddToToDoList(NewFile, TDUpload);
               StuffToDo.TotUp:=StuffToDo.TotUp+NewFile.Local.Size;
            end;
            NumLocalFiles:=NumLocalFiles+1;
            if Now-t>(RefreshDelay/2) then begin
               FrmProgress.LstActive.Items[0].SubItems[0]:='Scanning local copy: '+
                                                           'Found '+inttostr(LocalDirs.Count)+
                                                           ' directories, containing '+
                                                           inttostr(NumLocalFiles)+
                                                           ' files';
               CActive:=true;
               UpdateToDo;
               Application.ProcessMessages;
               t:=now;
            end;
        end;
    end;
{    FrmProgress.LstActive.Items[0].SubItems[0]:='Idle. Local copy contains '+
                                                inttostr(LocalDirs.Count)+
                                                ' directories, with a total of '+
                                                inttostr(NumLocalFiles)+
                                                ' files';}
    FrmProgress.LstActive.Items[0].SubItems[0]:='';
    CActive:=true;;
    UpdateToDo;
    FileList.Destroy;
end;



procedure MainLoop;
var a: integer;
    TempDir: PTDirInfo;
begin
     for a:=0 to 8 do begin
         LastDir[a]:='';
         if a>FrmMain.SpnNumConnections.Value then
            FrmProgress.LstActive.Items[a].SubItems[0]:='Not in use'
         else
            FrmProgress.LstActive.Items[a].SubItems[0]:='Waiting for instructions';
     end;
     FrmProgress.LstActive.Items[0].SubItems[0]:='Getting ready to go...';
     Application.ProcessMessages;

     Connection[1]:=FrmProgress.FTPClient1;
     Connection[2]:=FrmProgress.FTPClient2;
     Connection[3]:=FrmProgress.FTPClient3;
     Connection[4]:=FrmProgress.FTPClient4;
     Connection[5]:=FrmProgress.FTPClient5;
     Connection[6]:=FrmProgress.FTPClient6;
     Connection[7]:=FrmProgress.FTPClient7;
     Connection[8]:=FrmProgress.FTPClient8;

     InitFileData;
     InitToDoLists;
     UpdateToDo;
     ReadLocalDirectories;
     new(TempDir);
     TempDir.Name:='';
     AddToToDoList(TempDir, TDRemReadDir);
     UpdateToDo;
     Connect;
end;



function StrForLen(l: integer): string;
begin
     if l>1024*1024*10 then result:=' ('+IntToStr(Trunc(L/1024/1024))+'M)'
                       else result:=' ('+IntToStr(Trunc(L/1024))+'K)';
end;
procedure UpdateToDo;
var a: integer;
begin
     with FrmProgress.LstToDo do begin
          for a:=0 to 8 do begin
              Items[a].SubItems[1]:=IntToStr(StuffToDo.Num[a]);
              Items[a].SubItems[2]:=IntToStr(StuffDoing.Num[a]);
              Items[a].SubItems[3]:=IntToStr(StuffDone.Num[a]);
          end;
          Items[TDUpload].SubItems[1]:=Items[TDUpload].SubItems[1]+StrForLen(StuffToDo.TotUp);
          Items[TDUpload].SubItems[2]:=Items[TDUpload].SubItems[2]+StrForLen(StuffDoing.TotUp);
          Items[TDUpload].SubItems[3]:=Items[TDUpload].SubItems[3]+StrForLen(StuffDone.TotUp);
          Items[TDDownload].SubItems[1]:=Items[TDDownload].SubItems[1]+StrForLen(StuffToDo.TotDown);
          Items[TDDownload].SubItems[2]:=Items[TDDownload].SubItems[2]+StrForLen(StuffDoing.TotDown);
          Items[TDDownload].SubItems[3]:=Items[TDDownload].SubItems[3]+StrForLen(StuffDone.TotDown);
          CToDo:=true;;
     end;
end;

procedure Sleep;
var t: TDateTime;
    a: integer;
begin
     t:=now;
     while now-t<SleepTime do
{           for a:=1 to SleepLoop do}
               Application.ProcessMessages;
end;


end.
