unit Longfile;

interface
uses WinProcs, SysUtils, Dialogs, classes;
const
  DOSError : word = 0;
type
  TFiletime = record
    { The FILETIME structure is a 64-bit value representing the number of
      100-nanosecond intervals since January 1, 1601. }
    dwLowDateTime,
    dwHighDateTime : longint;
  end;
const
  MAX_PATH = 260;
type
  TWIN32_Find_Data = record
    dwFileAttributes : longint;
    ftCreationTime,
    ftLastAccessTime,
    ftLastWriteTime : TFILETIME;
    nFileSizeHigh,
    nFileSizeLow,
    dwReserved0,
    dwReserved1 : longint;
    cFileName : array[0..MAX_PATH ] of char;
    cAlternateFileName : array[0..14] of char;
  end;
function FindFirstFile(MustMatchAttrs,SearchAttrs:byte;
                       Filename:PChar; var FindData:TWIN32_Find_Data;
                       DateTimeFormat:word;
                       var Handle:word;
                       var ConversionCode:word):boolean;
function FindNextFile(Handle:word;var FindData:TWIN32_Find_Data;
                      DateTimeFormat:word;
                      var ConversionCode:word):boolean;
function FindClose(Handle:word):boolean;
function GetLongName(sname: string):string;
function GetLongSpec(sname: string):string;



implementation


function FindFirstFile(MustMatchAttrs,SearchAttrs:byte;
                       Filename:PChar; var FindData:TWIN32_Find_Data;
                       DateTimeFormat:word;
                       var Handle:word;
                       var ConversionCode:word):boolean;
assembler;
asm
  mov ax, 714Eh             { Find First File }
  mov ch, MustMatchAttrs
  mov cl, SearchAttrs
  lds dx, Filename
  les di, FindData
  mov si, DateTimeFormat

  call dos3call

  jnc @1
  mov bx,ax
  mov al,false
  jmp @2
@1:
  lds si,Handle
  mov [si], ax
  lds si,ConversionCode
  mov [si], cx
  xor bx,bx
  mov al,true
@2:
  mov dx,seg @data
  mov ds,dx
  mov DOSError, bx
end;

function FindNextFile(Handle:word;var FindData:TWIN32_Find_Data;
                      DateTimeFormat:word;
                      var ConversionCode:word):boolean;
assembler;
asm
  mov ax, 714Fh            { Find Next File }
  mov bx, Handle
  les di, FindData
  mov si, DateTimeFormat

  call dos3call

  jnc @1
  mov bx,ax
  mov al,false
  jmp @2
@1:
  lds si,ConversionCode
  mov [si], cx
  xor bx,bx
  mov al,true
@2:
  mov dx,seg @data
  mov ds,dx
  mov DOSError, bx
end;

function FindClose(Handle:word):boolean;
assembler;
asm
  mov ax, 71A1h   { Find Close }
  mov bx, Handle

  call dos3call

  jnc @1
  mov bx,ax
  mov al,false
  jmp @2
@1:
  xor bx,bx
  mov al,true
@2:
  mov dx,seg @data
  mov ds,dx
  mov DOSError, bx
end;


function GetLongName(sname: string):string;
var
  filename : array[0..255] of char;
  finddata : TWin32_Find_Data;
  handle,conversioncode : word;
begin
  StrPCopy(filename, SName);
  if FindFirstFile(0,$10,filename,finddata,1 ,handle, conversioncode) then
  begin
    Result:=StrPas(finddata.cFileName);
    if (conversioncode and 1) <> 0 then
      MessageDlg('LFN contains unconvertable chars!',mtInformation,[mbOK],0);
    if (conversioncode and 2) <> 0 then
      MessageDlg('SFN contains unconvertable chars!',mtInformation,[mbOK],0);
    FindClose(handle);
  end else
    Result:= 'Failed!';
end;



function GetLongSpec(sname :string):string;
var p: integer;
    cname : string;
    lname : string;
    cpart : string;
    tname : string;
{    log   : TStringList;}
begin
{  log:=TStringList.Create;
  log.add('');
  log.add(sname);
  Log.SaveToFile('c:\longfile.log');}
  cpart:='';
  lname:='';
  cname:='';
  for p:=1 to length(sname) do begin
    if sname[p]='\' then begin
      if (length(cpart)>1) and (cpart[2]=':') then begin
        cname:=cpart;
        lname:=cpart;
        cpart:='';
        chdir(cname+'\');
      end else begin
        chdir(cname);
        cname:=cname+'\'+cpart;
        tname:=GetLongName(cpart);
{        tname:='bollocks!';}
        if pos(' ',tname)>0 then tname:='"'+tname+'"';
        lname:=lname+'\'+tname;
        cpart:='';
      end;
    end else begin
      cpart:=cpart+sname[p];
    end;
{    log.add(cpart+' + '+sname+'   '+IntToStr(p)+'  '+cname+'  '+lname);
    Log.SaveToFile('c:\longfile.log');}
  end;
  if length(cpart)<>0 then begin
    chdir(cname);
    cname:=cname+'\'+cpart;
    tname:=GetLongName(cpart);
{    tname:='bollocks!';}
{    if pos(' ',tname)>0 then tname:='"'+tname+'"';}
    lname:=lname+'\'+tname;
    cpart:='';
  end;
{  log.add(cpart+' + '+sname+'   '+IntToStr(p)+'  '+cname+'  '+lname);
  log.add(lname);
  Log.SaveToFile('c:\longfile.log');
  Log.Free;}
  Result:=lname;
end;



{function GetLongSpec(sname: string):string;
var
  filename : array[0..255] of char;
  finddata : TWin32_Find_Data;
  handle,conversioncode : word;
  ts1, ts2, sname2 :string;
  p: integer;
begin
  StrPCopy(filename, SName);
  if FindFirstFile(0,$10,filename,finddata,1,handle, conversioncode) then
  begin
    ts1:=copy(sname,1,3);
    ts2:=copy(sname,4,250);
    if pos('\',ts2)=0 then Result:=ts1+StrPas(finddata.cFileName)
    else begin
      p:=length(sname);
      while sname[p]<>'\' do dec(p);
      sname2:=copy(sname,1,p-1);
      Result:=GetLongSpec(sname2)+'\'+StrPas(finddata.cFileName);
    end;
    if (conversioncode and 1) <> 0 then
      messagedlg('LFN contains unconvertable chars!',mtInformation,[mbOK],0);
    if (conversioncode and 2) <> 0 then
      messagedlg('SFN contains unconvertable chars!',mtInformation,[mbOK],0);
    FindClose(handle);
  end else
    Result:= 'Failed!';
end;}


end.
