unit filedata;

interface

uses classes, GPRog, GConst;

type TFileDateSize = record
     dd, dm, dy, th, tm, ts: integer;
     Size: Integer;
end;
type PTDirInfo = ^TDirInfo;
     PTFileInfo = ^TFileInfo;

     TFileInfo = record
     Name: string;
     Local: TFileDateSize;
     Remote: TFileDateSize;
     Dir: PTDirInfo;
     end;

     TDirInfo = record
     Name: string;
     Local, Remote: Boolean;
     Files: TList;
     Uploaded: boolean;
     end;

function AddDirectory(Name: String; DefNew: boolean): PTDirInfo;
function AddFile(Name: String; DefNew: boolean; Dir: PTDirInfo): PTFileInfo;
function PathToInternal(I: String): String;
function GetParamPath(I: string): string;
function GetParamFileNAme(I: string): string;
procedure InitFileData;
function ToWindoze(I: String): String;


implementation

var LDirs: TList;



procedure InitFileData;
var a, b: integer;
    TD: PTDirInfo;
    TF: PTFileInfo;
begin
     for a:=0 to LDirs.Count-1 do begin
         TD:=LDirs.Items[a];
         TD.Files.Clear;
     end;
     LDirs.Clear;
end;


function GetParamPath(I: string): string;
var a: integer;
    t: string;
begin
     t:=I;
     result:='';
     while pos('/', t)<>0 do begin
           result:=result+copy(t, 1, pos('/', t));
           t:=copy(t, pos('/', t)+1, BIG_INT);
     end;
end;
function GetParamFileName(I: string): string;
var a: integer;
    t: string;
begin
     t:=I;
     while pos('/', t)<>0 do begin
           t:=copy(t, pos('/', t)+1, BIG_INT);
     end;
     result:=t;
end;


function PathToInternal(I: String): String;
var a: integer;
    p: string;
begin
     p:=copy(I, length(LocalRoot), BIG_INT);
     for a:=1 to length(p) do begin
         if p[a]='\' then p[a]:='/';
     end;
     if copy(p, 1, 1)='/' then p:=copy(p, 2, BIG_INT);
     if copy(p, length(p), 1)='/' then p:=copy(p, 1, length(p)-1);
     result:=p;
end;
function ToWindoze(I: String): String;
var a: integer;
    p: string;
begin
     p:=I;
     for a:=1 to length(I) do begin
         if I[a]='/' then p[a]:='\'
     end;
     result:=p;
end;


function AddFile(Name: String; DefNew: boolean; Dir: PTDirInfo): PTFileInfo;
var TempFile: PTFileInfo;
    a, b: integer;
begin
     if DefNew then begin
        new(TempFile);
        TempFile.Name:=Name;
        TempFile.Dir:=Dir;
        Dir.Files.Add(TempFile);
     end else begin
         b:=-1;
         for a:=0 to Dir.Files.Count-1 do begin
             TempFile:=Dir.Files[a];
             if TempFile.Name=Name then b:=a;
         end;
         if b=-1 then begin
            new(TempFile);
            TempFile.Name:=Name;
            TempFile.Dir:=Dir;
            Dir.Files.Add(TempFile);
         end else begin
            TempFile:=Dir.Files[b];
         end;
     end;
     result:=TempFile;
end;


function AddDirectory(Name: String; DefNew: boolean): PTDirInfo;
var TempDir: PTDirInfo;
    a, b: integer;
begin
     if DefNew then begin
        new(TempDir);
        TempDir.Name:=Name;
        TempDir.Files:=TList.Create;
        LDirs.Add(TempDir);
     end else begin
         b:=-1;
         for a:=0 to LDirs.Count-1 do begin
             TempDir:=LDirs[a];
             if TempDir.Name=Name then b:=a;
         end;
         if b=-1 then begin
            new(TempDir);
            TempDir.Name:=Name;
            LDirs.Add(TempDir);
         end else begin
             TempDir:=LDirs[b];
         end;
     end;
     result:=TempDir;
end;




Initialization
   LDirs:=TList.Create;

end.
